package org.RI.P1;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.List;
import java.util.stream.Collectors;

import org.apache.tika.exception.TikaException;
import org.xml.sax.SAXException;

public class AnalyzeDirectory {
    private static List<File> files;

    private static void readFiles(String directory) throws IOException {
        files = Files.walk(Paths.get(directory)).filter(Files::isRegularFile).map(Path::toFile)
                .collect(Collectors.toList());
    }

    private static void usage() {
        System.out.println("Usage: AnalyzeDirectory <directory> <option>");
        System.out.println("option metadata: shows the filename/file type/encoding and language of the files");
        System.out.println("option links: shows all the links contained in each file");
        System.exit(1);
    }

    private static void chooseAction(String action) {
        for (File file : files) {
            FileData data = new FileData(file);
            if (action == "metadata") {
                System.out.println(data);
            } else if (action == "links") {
                data.getLinks();
            } else {
                usage();
            }
            System.out.println("--------------------------------------------------------------------------");
        }
    }

    public static void main(String[] args) throws IOException, TikaException, SAXException {
        if (args.length != 2) {
            usage();
        }
        String directory = args[0];
        readFiles(directory);
        chooseAction(args[1]);
    }

}
